mobFunctions = {}
local mob = {}

function mobFunctions:add(x,y, speed)

	
	table.insert(mob, {x = x, y = y, animation = newAnimation(love.graphics.newImage("images/playerr.png"), 119, 227, 0.07+((speed/10000)*2), 0), speed = speed, })
end

function mobFunctions:remove(index)
	table.remove(index)
end


function mobFunctions:draw(state)
	local dt = love.timer.getDelta()
	for i,v in ipairs(mob) do
		local dx = (player.x - v.x)
		local dy = (player.y - v.y)
		local dist = math.sqrt ( dx^2 + dy^2 )
		
		if state == 'foreground' and v.y+89 > player.y then
			if dx < 0 then
				v.animation:draw(v.x, v.y, 0, -1, 1, 50, 179)
			else
				v.animation:draw(v.x, v.y, 0, 1, 1, 50, 179)
			end
		elseif state == 'background' and v.y+89 < player.y then
			if dx < 0 then
				v.animation:draw(v.x, v.y, 0, -1, 1, 50, 179)
				love.graphics.draw(cross,v.x,v.y)
			else
				v.animation:draw(v.x, v.y, 0, 1, 1, 50, 179)
			end

		else
			
		end	

	end

end

function mobFunctions:update(dt)
	local dt = love.timer.getDelta()

	for i,v in ipairs(mob) do
		local dx = (player.x - v.x)
		local dy = (player.y - v.y)
		local dist = math.sqrt ( dx^2 + dy^2 )
		if dist <10 then
		player.health=player.health-0.5-((math.random()*2))
		v.x=v.x-11
		if v.x<shootx and v.x<shootx+20 and v.y>shooty-20 and v.y<shooty+20 then
		v.x=v.x-50
		end
		
		end


		if dist > 5 then
		
			v.animation:update(dt)
			v.x = v.x + dx / dist * (dt * v.speed)
			v.y = v.y + dy / dist * (dt * v.speed)
		end
	end
end
