require "include/AnAL"
require "include/vector"
require "include/camera"
require "include/TEsound"
require "include/Player"
require "include/items"
require "include/levels"
require "include/Mob"
require "include/Bullet"

gui = {}
math.randomseed(love.timer.getDelta()*1128734+os.time())
math.randomseed(love.timer.getDelta()*1128734+os.time())
math.random(200)math.random(200)

function love.load()
	-- Ljudet
	TEsound.playLooping("audio/music.mp3", "music")
	TEsound.tagVolume("music",.7)
	-- Variabler
	zombiekills=0
	pot=0
	potreg=0
	shoot=0
	shootx=0
	shootd=0
	
	--Bilder!
	m = love.graphics.newImage("images/machine.png")
	m2 = love.graphics.newImage("images/machine2.png")
	m3 = love.graphics.newImage("images/machine3.png")
	b = love.graphics.newImage("images/blood.png")
	s = love.graphics.newImage("images/screen.png")
	bullet = love.graphics.newImage("images/shoot.png")
	cross = love.graphics.newImage("images/cross.png")
	
	--Hp
	hundred = love.graphics.newImage("images/hp/hundred.png")
	seventyfive = love.graphics.newImage("images/hp/seventyfive.png")
	fifty = love.graphics.newImage("images/hp/fifty.png")
	twentyfive = love.graphics.newImage("images/hp/twentyfive.png")
	
	cam = Camera(vector(love.graphics.getWidth()/2,love.graphics.getHeight()/2), 1, 0)
	
	--Banor
	levelFunctions:new("images/level.png")
	
	
	
	--Koden fr liv-ldor
	local tempFunc = function(i,v)
		potreg=700
	end
	
	
	for i = 1,5 do
		--Frstahjlpen
			itemsFunctions:new("images/health.png",  math.random(200,3300), math.random(500,580), true,true, tempFunc)
		--itemsFunctions:new("sprites/gold.png", 1200, 500, true, tempFunc)
	end
   tempFunc = nil
   	
	mobFunctions:add(400,555,90+math.random(20))
	mobFunctions:add(400,758,90+math.random(20))
	
	-- Mer zombies om man ddar
	for i = 1,zombiekills*5 do
	mobFunctions:add(400,555,90+math.random(20))
	end

end
function love.keypressed(k)
    if k == 'escape' then
        love.event.push('q')
    end
end
--Hr brjas skottet
function love.keypressed(key)
	if key == ' ' then
	if shoot==0 then
		shoot = 2
		TEsound.play("audio/shotgun.wav","soundeffects")
		if player.dir==1 then
		shootd=1
		else
		shootd=0
		end
		end
	end
end


function love.update(dt)
	if player.health<1 then
	love.event.push('q')
	player.health=2
	end
	TEsound.cleanup()
	player:update(dt)
	cameraUpdate()
	--Liv-ldan brjar hela
	if potreg>0 then
	potreg=potreg-1
	pot=0.005
	end
	--Hr slutar den hela nr potreg=0
	if potreg==0 then
	pot=0
	end

	--Hr flyger skottet i luften
	if shoot>1 then
	shoot=shoot+2
		shooty=player.y-74
	if shootd==1 then
	shootx=35+player.x+shoot
	else
	shootx=player.x-35-shoot
	end

	end
	
	--Nr skottet har flygigt 550 pixelar frsvinner den
	if shoot>550 then
	shoot=0
	shootx=-50
	shooty=-50
	end

	--HPreg
	if player.health<75 then
	player.health=player.health+0.0003+pot
	end	
	
	if player.health<50 then
	player.health=player.health+0.001+pot
	end
	
	if player.health<100 then
	player.health=player.health+0.0002+pot
	end
	
end

function love.draw()
	cam:draw(inCameraFrame)
	gui:run()
end

-- Hr placeras allt som tillhr GUI
function gui:run()

	--Debug!
	--love.graphics.print(player.health, 32, 20)
	--love.graphics.print(player.health/100, 32, 30)
	--love.graphics.print(potreg, 32, 40)
	--love.graphics.print(player.dir, 32, 66)
	--love.graphics.print("Debug (" .. dist.. ")", 32, 86)
	
	--love.graphics.print(player.health, 32, 1000)
	
	--Hr ritas "huvudet"
	if player.health>75 then love.graphics.draw(hundred,25,542) end
	if player.health>50 and player.health<75 then love.graphics.draw(seventyfive,25,542) end
	if player.health>25 and player.health<50 then love.graphics.draw(fifty,25,542) end
	if player.health<25 then love.graphics.draw(twentyfive,25,542) end
	
	-- HP-bar
	love.graphics.setColor(255,155+player.health,155+player.health,255)
	love.graphics.rectangle("fill", 110, 560, player.health, 20)

	--love.graphics.draw(m,15,442)
	--love.graphics.draw(b,19,583-100)
	--love.graphics.draw(s,19,488)
	--love.graphics.draw(m2,15,546)
	--love.graphics.draw(m3,15,484)
end

--Allt hr r i focus fr kameran
function inCameraFrame()

	--Allt i bakgrunden
	levelFunctions:draw()
	itemsFunctions:draw('background')
	mobFunctions:draw('background')	
	
	--Uppdatera script
	mobFunctions:update()
	
	--Vilket hll man tittar t
	if player.run then
		player.anim:play()
	else
		player.anim:seek(1)
		player.anim:stop()
	end
	
	--Skottet
	love.graphics.draw(bullet,shootx,shooty)
	
	--Spelaren
	player.anim:draw(player.x, player.y, 0, player.dir, 1, 50, 179)
	--love.graphics.draw(cross,player.x,player.y)

	--Allt i framsidan
	itemsFunctions:draw('foreground')
	mobFunctions:draw('foreground')		
end

--Uppdaterar s att kameran frljer efter spelaren
function cameraUpdate()

	if player.x <= love.graphics.getWidth()/2 then
		camX = love.graphics.getWidth()/2
	elseif player.x >= levels[player.currentLevel].img:getWidth() - love.graphics.getWidth()/2 then
		camX = levels[player.currentLevel].img:getWidth() - love.graphics.getWidth()/2
	else
		camX = player.x
	end
	cam:setPos(vector(camX,love.graphics.getHeight()/2))


end
